#!/usr/bin/env python3

# exemple de script de participation
# la forme acceptee est totalement libre, tant que le script:
# - n'altere pas les fonctions ou variables de pyka3dlb.py
# - n'accede a aucune variable de pyka3dlb.py
# - n'accede a aucune fonction de pyka3dlb.py en dehors de jouer_selon()

# modifie/complete/remplace la liste des actions afin de realiser le meilleur score

from pyka3dlb import *
from math import pi

# actions possibles
# pas_en_avant, pas_a_droite, pas_en_arriere, pas_a_gauche, pause, tourne_a_gauche, tourne_a_droite, saute = range(8) # 0 1 2 3 4 5 6 7

# valeurs prises en compte pour les parametres :
# de -1 a 1 pour les deplacements par pas (longueur du pas)
# de 0 a 1 pour le saut (force du saut)
# tout nombre reel pour les rotations (angle en radians) ou pauses (ignore)

# tour = 2 * pi

# documentation format <liste_action> :
# list_actions = [
#   pas_en_avant   , 1     , # avance de 1 pas
#   pas_en_avant   , .5    , # avance d'un demi-pas
#   pas_en_arriere , 1     , # recule de 1 pas
#   pas_en_arriere , .25   , # recule d'un quart de pas
#   tourne_a_gauche, tour/2, # tourne d'un demi-tour à gauche
#   tourne_a_droite, tour/4, # tourne d'un quart de tour à droite
#   pas_a_gauche   , 1     , # se decale vers la gauche de 1 pas
#   pas_a_droite   , .5    , # se decale vers la droite d'un demi-pas
#   saute          , 1     , # saute a force maximale
# ]

# exemple <liste_actions>
liste_actions = [4, 5, 6, 0.39269908169872414, 6, 0.39269908169872414, 6, 0.39269908169872414, 6, 0.39269908169872414, 6, 0.39269908169872414, 5, 0.39269908169872414, 5, 0.39269908169872414, 5, 0.39269908169872414, 5, 0.39269908169872414, 5, 0.39269908169872414, 5, 0.39269908169872414, 0, 77, 5, 0.39269908169872414, 0, 121]
#liste_actions = []



# exemples appels jouer_selon()

# joue la liste d'actions <liste_actions>, avec affichages intermediaires
score, liste_actions_clavier = jouer_selon(liste_actions, True)

# joue la liste d'actions <liste_actions>, sans affichages intermediairesscore
#score, liste_actions_clavier = jouer_selon(liste_actions, False)

# le clavier permet d'interrompre la lecture avec [esc]
# en fin de lecture (interrompue ou fin de liste), le clavier permet rajouter de nouvelles actions :
# [Haut]   = avance de 1 pas
# [Bas]    = recule de 1 pas
# [Gauche] = tourne a gauche d'un 16eme de tour (pi/8 radians)
# [Droite] = tourne a droite d'un 16eme de tour (pi/8 radians)
# [4]      = decale de 1 pas a gauche
# [6]      = decale de 1 pas a droite
# [5]      = ne bouge pas (passe son tour)
# [enter]  = saute a force maximale

# la liste des actions ajoutees au clavier est enregistree dans la variable globale <liste_actions_clavier>
# les nouvelles valeurs sont recuperables et collables sur les lignes precedentes par affichage/consultation de cette variable

if __name__ == "__main__": print(liste_actions_clavier)
print(score)

# Bon score ?
# Envoie ton script pyka3d.py complete avec la liste des actions t'ayant permis de le realiser a info@tiplanet.org
